﻿#ifndef REALSENSE2CV_H
#define REALSENSE2CV_H

#define _CRT_SECURE_NO_WARNINGS
#include <pxcsensemanager.h>
#include <opencv2/opencv.hpp>

class TRealSense2CV
{
private:
  PXCSenseManager *sm;
  Intel::RealSense::Device *device;
  PXCProjection *projection;
  PXCCapture::Sample *sample;
  cv::Mat colorMat;
  cv::Mat depthMat, depth16Mat, depth32Mat;
  cv::Mat ifredMat;
  cv::Mat TRealSense2CV::PXCcolor2Mat(PXCImage *pxcImage, Intel::RealSense::Image::PixelFormat format);
  cv::Mat TRealSense2CV::PXCdepth162Mat(PXCImage *pxcImage, Intel::RealSense::Image::PixelFormat format);
  cv::Mat TRealSense2CV::PXCdepth322Mat(PXCImage *pxcImage, Intel::RealSense::Image::PixelFormat format);
  cv::Mat TRealSense2CV::PXCifred2Mat(PXCImage *pxcImage, Intel::RealSense::Image::PixelFormat format);

public:
  TRealSense2CV();
  ~TRealSense2CV();
  bool init();
  bool queryFrame();
  cv::Mat color();
  cv::Mat depth();
  cv::Mat depth16();
  cv::Mat depth32();
  cv::Mat ifred();
  std::vector<cv::Point3d> TRealSense2CV::depth2camera();
};

#endif
